#! /bin/sh
# Run this to generate all the initial makefiles, etc.

package="PAF"

CONFIGURE_DEF_OPT='--enable-maintainer-mode --enable-gtk-doc'

# change dir if we're not at home (where $0 is):
our_path=$0
our_path=`dirname $our_path`
cd ${our_path}

echo "+ running gtkdocize ... "
echo "  gtkdocize"
gtkdocize || {
        echo "  gtkdocize failed"
        exit 1
}

echo
echo "+ running autoreconf ... "
echo "  autoreconf -v --install"
autoreconf -v --install -Wno-portability|| {
        echo "  autoreconf failed"
        exit 1
}

echo
echo "+ running configure ... "
test ! -z "$CONFIGURE_DEF_OPT" && echo "  ./configure default flags: $CONFIGURE_DEF_OPT"
echo "  ./configure external flags: $@"
./configure $CONFIGURE_DEF_OPT "$@" || {
        echo "  configure failed"
        exit 1
}

echo
echo "Now type 'make' to compile $package."
