/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework - Clock
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */

/**
 * SECTION:paf
 * @short_description: A library to animate things.
 * @see_also: #PafClock, #PafAnimation, #PafModifier, #PafImplicitAnimator
 *
 * <refsect2>
 * <para>
 * FIXME
 * </para>
 * </refsect2>
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include "paf.h"

/**
 * paf_version:
 * @major: a pointer to a #guint to store the major version number.
 * @minor: a pointer to a #guint to store the minor version number.
 * @micro: a pointer to a #guint to store the micro version number.
 * @nano: a pointer to a #guint to store the nano version number.
 *
 * Gets the version number of the PAF Animation Framework.
 */
void
paf_version (guint *major, guint *minor, guint *micro, guint *nano)
{
}

/**
 * paf_version_string:
 *
 * Returns a string that is useful for describing this version of PAF to
 * the outside world: user agent strings, logging, etc.
 *
 * Returns: a newly allocated string describing this version of PAF.
 */
gchar *
paf_version_string (void)
{
    return NULL;
}

/**
 * paf_get_default_ticker:
 *
 * Returns the default ticker. Creates it if it hasn't been created before. This
 * is the ticker that ticks a #PafClock by default.
 *
 * Returns: the default ticker.
 */
PafTicker *
paf_get_default_ticker (void)
{
    return NULL;
}

/**
 * paf_init:
 *
 * You need to call paf_init() before calling any other function of the PAF
 * Animation Framework, unless you know what you are doing.
 *
 */
void
paf_init (void)
{
    g_type_init ();
    if (!g_thread_supported ())
        g_thread_init (NULL);

    /* creates the default ticker */
    paf_get_default_ticker ();
}

/* FIXME: shouldn't there be some kind of pafcommon.c for this ? */
/**
 * paf_accumulate_booleans:
 * @invocation_hint:
 * @_return_accumulator:
 * @_handler_return:
 * @data:
 */
gboolean
paf_accumulate_booleans (GSignalInvocationHint *invocation_hint,
                     GValue *_return_accumulator,
                     const GValue *_handler_return,
                     gpointer data)
{
    gboolean handler_return = g_value_get_boolean (_handler_return);
    gboolean return_accumulator = g_value_get_boolean (_return_accumulator);

    g_value_set_boolean (_return_accumulator,
                         return_accumulator || handler_return);

    return TRUE;
}

