/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */

#ifndef __HAVE_PAF_H__
#define __HAVE_PAF_H__

#include "pafversion.h"
#include "pafticker.h"
#include "pafclock.h"
#include "pafanimation.h"
#include "pafimplicitanimator.h"
#include "paftransformation.h"
#include "pafinterpolation.h"
#include "pafoperators.h"

G_BEGIN_DECLS

void    paf_init (void);

void    paf_version         (guint *major,
                             guint *minor,
                             guint *micro,
                             guint *nano);

gchar  *paf_version_string  (void);

PafTicker * paf_get_default_ticker (void);


G_END_DECLS

#endif /* __HAVE_PAF_H__ */
