/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */

/**
 * SECTION:pafanimation
 * @short_description: FIXME
 * @see_also: #PafImplicitAnimator, #PafClock and #PafTransformation.
 *
 * <refsect2>
 * FIXME
 * </refsect2>
 */

#include "pafanimation.h"

G_DEFINE_TYPE (PafAnimation, paf_animation, G_TYPE_OBJECT);

#define PAF_ANIMATION_GET_PRIVATE(o)\
    (G_TYPE_INSTANCE_GET_PRIVATE ((o), PAF_TYPE_ANIMATION, PafAnimationPrivate))

struct _PafAnimationPrivate {
    GSList     *transformations;
    PafClock   *clock;
};

/* property IDs */
enum {
    CLOCK=1,
    STATE,
    LAST_PROPERTY
};

static void
paf_animation_set_property (GObject      *object,
                            guint         property_id,
                            const GValue *value,
                            GParamSpec   *pspec)
{
}

static void
paf_animation_get_property (GObject      *object,
                            guint         property_id,
                            GValue       *value,
                            GParamSpec   *pspec)
{
}


static void
paf_animation_dispose (PafAnimation *self)
{
}

static void
paf_animation_finalize (PafAnimation *self)
{
}

static void
paf_animation_init (PafAnimation *self)
{
    PafAnimationPrivate *priv;

    priv = PAF_ANIMATION_GET_PRIVATE (self);
}

static void
paf_animation_class_init (PafAnimationClass *self_class)
{
    GObjectClass *object_class = G_OBJECT_CLASS (self_class);
    GParamSpec *param_spec = NULL;

    g_type_class_add_private (self_class, sizeof (PafAnimationPrivate));

    object_class->set_property = paf_animation_set_property;
    object_class->get_property = paf_animation_get_property;

    param_spec = g_param_spec_object ("clock", "Clock",
                                      "Clock that controls the timing of the "
                                      "animation",
                                      PAF_TYPE_CLOCK,
                                      G_PARAM_READWRITE
                                      | G_PARAM_CONSTRUCT_ONLY);
    g_object_class_install_property (object_class, CLOCK, param_spec);

    /**
     * PafAnimation:state:
     *
     * A #PafState saying whether the animation (and therefore its
     * #PafAnimation:clock property) is stopped, running or paused.
     */
    param_spec = g_param_spec_uint ("state", "State",
                                    "The state of the clock",
                                    0, PAF_LAST_STATE, PAF_STATE_STOPPED,
                                    G_PARAM_READWRITE | G_PARAM_CONSTRUCT);
    g_object_class_install_property (object_class, STATE, param_spec);


    object_class->dispose = (void (*) (GObject *object)) paf_animation_dispose;
    object_class->finalize =
        (void (*) (GObject *object)) paf_animation_finalize;
}

/* public methods */

PafAnimation *
paf_animation_new (PafClock *clock)
{
    return NULL;
}

PafAnimation *
paf_animation_new_from_duration (guint duration)
{
    return NULL;
}

void
paf_animation_add_transformation (PafAnimation *animation,
                            PafTransformation *transformation)
{
}

gboolean
paf_animation_remove_transformation (PafAnimation *animation,
                               PafTransformation *transformation)
{
    return FALSE;
}

gboolean
paf_animation_has_transformation (PafAnimation *animation,
                                  const PafTransformation *transformation)
{
    return FALSE;
}

void
paf_animation_add_transformations (PafAnimation *animation,
                                   PafTransformation *first_transformation,
                                   ...)
{
}

void
paf_animation_add_transformations_valist (PafAnimation *animation,
                                               va_list var_args)
{
}

void
paf_animation_add_transformation_list (PafAnimation *animation,
                                            GSList *list)
{
}

PafClock *
paf_animation_get_clock (PafAnimation *animation)
{
    return NULL;
}

PafState
paf_animation_get_state (PafAnimation *animation)
{
    return PAF_STATE_STOPPED;
}

void
paf_animation_set_state (PafAnimation *animation,
                         PafState state)
{
}

