/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework - Interpolation - key values
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */
#ifndef __PAF_KEY_VALUE_H__
#define __PAF_KEY_VALUE_H__

#include "pafcommon.h"

typedef struct _PafKeyValue PafKeyValue;

struct _PafKeyValue {
    gfloat fraction;
    GValue *value;
    GValue *options;
};

#define PAF_TYPE_KEY_VALUE (paf_key_value_get_type ())

GType           paf_key_value_get_type (void);

PafKeyValue *   paf_key_value_new (gfloat fraction,
                                 GValue *value,
                                 gpointer options);

PafKeyValue *   paf_key_value_copy (PafKeyValue *value);

void            paf_key_value_free (PafKeyValue *value);


#endif /* __PAF_KEY_VALUE_H__ */
