/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */

/**
 * SECTION:pafmodifier
 * @short_description: FIXME
 * @see_also: #PafTransformation
 *
 * <refsect2>
 * FIXME
 * </refsect2>
 */

#include "pafmodifier.h"

G_DEFINE_TYPE (PafModifier, paf_modifier, G_TYPE_OBJECT);

#define PAF_MODIFIER_GET_PRIVATE(o)\
    (G_TYPE_INSTANCE_GET_PRIVATE ((o), PAF_TYPE_MODIFIER, PafModifierPrivate))

struct _PafModifierPrivate {
    /* Properties */
    PafValueSetterFunc value_setter;
    gpointer target_container;
    gpointer target_info;
};

/* PafModifier properties */
enum {
    VALUE_SETTER=1,
    TARGET_CONTAINER,
    TARGET_INFO,
    LAST_PROPERTY
};

/* GObject stuff */

static void
paf_modifier_set_property (GObject *self,
                           guint property_id,
                           const GValue *value,
                           GParamSpec *param_spec)
{
}

static void
paf_modifier_get_property (GObject *self,
                           guint property_id,
                           GValue *value,
                           GParamSpec *param_spec)
{
}

static void
paf_modifier_dispose (PafModifier *self)
{
}

static void
paf_modifier_finalize (PafModifier *self)
{
}

static void
paf_modifier_init (PafModifier *self)
{
    PafModifierPrivate *priv;

    priv = PAF_MODIFIER_GET_PRIVATE (self);
}

static void
paf_modifier_class_init (PafModifierClass *klass)
{
    GObjectClass *object_class = G_OBJECT_CLASS (klass);
    GParamSpec *param_spec = NULL;

    g_type_class_add_private (klass, sizeof (PafModifierPrivate));

    object_class->set_property = paf_modifier_set_property;
    object_class->get_property = paf_modifier_get_property;

    param_spec = g_param_spec_pointer ("value-setter", "Value setter",
                                       "PafValueSetterFunc function used to "
                                       "do the actual modification",
                                       G_PARAM_READWRITE
                                       | G_PARAM_CONSTRUCT_ONLY);
    g_object_class_install_property (object_class, VALUE_SETTER, param_spec);

    param_spec = g_param_spec_pointer ("target-container", "Target container",
                                       "First parameter passed to the value "
                                       "setter",
                                       G_PARAM_READWRITE
                                       | G_PARAM_CONSTRUCT_ONLY);
    g_object_class_install_property (object_class, TARGET_CONTAINER,
                                     param_spec);

    param_spec = g_param_spec_pointer ("target-info", "Target info",
                                       "Second parameter passed to the value "
                                       "setter.",
                                       G_PARAM_READWRITE
                                       | G_PARAM_CONSTRUCT_ONLY);
    g_object_class_install_property (object_class, TARGET_INFO, param_spec);

    object_class->dispose = (void (*) (GObject *object)) paf_modifier_dispose;
    object_class->finalize = (void (*) (GObject *object)) paf_modifier_finalize;
}

/* Public methods */
PafModifier * paf_modifier_new (GObject *object, const gchar *property_name)
{
    return NULL;
}


PafModifier * paf_modifier_new_full (PafValueSetterFunc value_setter,
                                     gpointer target_container,
                                     gconstpointer target_info)
{
    return g_object_new (PAF_TYPE_MODIFIER,
                         "value-setter", value_setter,
                         "target-container", target_container,
                         "target-info", target_info, NULL);
}


gboolean paf_modifier_update (PafModifier *modifier, GValue *value)
{
    return FALSE;
}


/**
 * paf_gobject_value_setter:
 * @container: a #GObject.
 * @attribute_data: a property name (should be #gchar *).
 * @new_value: The new value to be set for the property.
 *
 * Default value setter for #PafModifier, which sets a property of a #GObject.
 */
gboolean paf_gobject_value_setter (gpointer container,
                                   gconstpointer attribute_data,
                                   GValue *new_value)
{
    return FALSE;
}

