/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */
#ifndef __PAF_MODIFIER_H__
#define __PAF_MODIFIER_H__

#include "pafcommon.h"

G_BEGIN_DECLS

typedef struct _PafModifierPrivate PafModifierPrivate;

typedef struct {
    GObject parent;

    PafModifierPrivate *priv;
} PafModifier;

typedef struct {
    GObjectClass parent;
} PafModifierClass;

#define PAF_TYPE_MODIFIER (paf_modifier_get_type ())
#define PAF_MODIFIER(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST ((obj), PAF_TYPE_MODIFIER, PafModifier))
#define PAF_MODIFIER_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST ((klass), PAF_TYPE_MODIFIER, PafModifierClass))
#define PAF_IS_MODIFIER(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PAF_TYPE_MODIFIER))
#define PAF_IS_MODIFIER_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE ((klass), PAF_TYPE_MODIFIER))
#define PAF_MODIFIER_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS ((obj), PAF_TYPE_MODIFIER, PafModifierClass))

/**
 * PafValueSetterFunc:
 * @container: FIXME
 * @attribute_data: FIXME
 * @new_value: FIXME
 *
 * FIXME
 * @returns: whether the change had any effect.
 */
typedef gboolean (*PafValueSetterFunc) (gpointer container,
                                        gconstpointer attribute_data,
                                        GValue *new_value);



GType paf_modifier_get_type (void);

PafModifier   * paf_modifier_new (GObject *object, const gchar *property_name);

PafModifier   * paf_modifier_new_full (PafValueSetterFunc value_setter,
                                     gpointer target_container,
                                     gconstpointer target_info);

gboolean        paf_modifier_update (PafModifier *modifier, GValue *value);

gboolean        paf_gobject_value_setter (gpointer container,
                                          gconstpointer attribute_data,
                                          GValue *new_value);

G_END_DECLS

#endif /* __PAF_MODIFIER_H__ */
