/* vi:expandtab:ts=4:sw=4:cindent:tw=80:cinoptions=(0,u0,t0
 *
 * PAF Animation Framework - Ticker
 *
 * Copyright © 2008 Fluendo Embedded S.L.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Author(s): Guillaume Emont <guillaume@fluendo.com>
 */

#ifndef __PAF_TICKER_H__
#define __PAF_TICKER_H__
#include "pafcommon.h"
#include "pafclock.h"

G_BEGIN_DECLS

typedef struct _PafTickerPrivate PafTickerPrivate;

struct _PafTicker {
    GObject parent;

    PafTickerPrivate *priv;
};

typedef struct {
    GObjectClass parent;
} PafTickerClass;

#define PAF_TYPE_TICKER (paf_ticker_get_type ())
#define PAF_TICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), \
                                                     PAF_TYPE_TICKER, \
                                                     PafTicker))
#define PAF_TICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), \
                                                          PAF_TYPE_TICKER, \
                                                          PafTickerClass))
#define PAF_IS_TICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PAF_TYPE_TICKER))
#define PAF_IS_TICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), \
                                                             PAF_TYPE_TICKER))
#define PAF_TICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), \
                                                              PAF_TYPE_TICKER, \
                                                              PafTickerClass))

GType paf_ticker_get_type (void);

PafTicker * paf_ticker_new          (void);

gboolean    paf_ticker_tick         (PafTicker *ticker);

gboolean    paf_ticker_has_clock   (PafTicker *ticker, const PafClock *clock);

/* internal functions */
void        _paf_ticker_add_clock    (PafTicker *ticker, PafClock *clock);
void        _paf_ticker_remove_clock (PafTicker *ticker, PafClock *clock);


G_END_DECLS

#endif /* __PAF_TICKER_H_ */
