# This is a list of proof of concept code snipets that often suppose the
# existence of stuff that doesn't exist. This probably won't compile ever, it
# is just a tool to test the validity of the API (and not its implementation)
# as it is developped. Hypothetic stuff have the prefix "magic", possibly with
# another capitalisation depending on the case.

# Move image's x position to dest in a smooth way. Explicit version.
def move_image(image, dest):
    interpolator = paf.LinearInterpolator(image, "x")
    interpolator.to = dest

    animation = paf.Animation(1000.0, interpolator)
    animation.start()

# Move image's x position linearly to dest. Implicit version.
def implicitly_move_image (image, dest):
    animator = paf.ImplicitAnimator(image)
    animator.x = dest

# Move image's x position smoothly to dest. Explicit version
def move_image_smooth(image, dest):
    interpolator = paf.LinearInterpolator(image, "x")
    interpolator.to = dest

    animation =
        paf.Animation(paf.Clock(2000, time_modifier=paf.EaseInOutModifier()),
                      interpolator)
    animation.start()

def move_image_smooth2(image, dest):
    interpolator = paf.LinearInterpolator(image, "x")
    interpolator.to = dest

    animation = paf.Animation(2000.0, interpolator)

    animation.clock.time_modifier=paf.EaseInOutModifier()

    animation.start()

def implicitly_move_image_smooth(image, dest)
    animator = paf.ImplicitAnimator(image)
    animator.set_time_modifier_type(paf.EASEINOUTMODIFIER)

    animator.x = dest

def implicitly_move_image_smooth2(image, dest)
    animator = paf.ImplicitAnimator(image,
                                    time_modifier_type=paf.EASEINOUTMODIFIER)
    animator.x = dest
